// --------------------------------------------------------
// Copyright (c)
//
// contributions by Ansgar
//                  ansgar.radermacher@cea.fr
// maintained by    CEA LIST
//                  info-list@cea.fr

// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#define sendReceive_SendClient_BODY

/************************************************************
 SendClient class body
 ************************************************************/

// Include from Include stereotype (pre-body)
#include <iostream>
using namespace std;
// End of Include stereotype (pre-body)

// include associated header file
#include "sendReceive/SendClient.h"

// Derived includes directives
#include "rclcpp/rclcpp.hpp"
#include "sendReceive/SendClient_main.h"

// Include from Include declaration (body)
#include "rclcpp_components/register_node_macro.hpp"

// Register the component with class_loader.
// This acts as a sort of entry point, allowing the component to be discoverable when its library
// is being loaded into a running process.
RCLCPP_COMPONENTS_REGISTER_NODE (sendReceive::SendClient)

// End of Include declaration (body)

namespace sendReceive {

// static attributes (if any)

/**
 * 
 */
void SendClient::fSendMap() {
  simple_msgs::msg::Map map;
  map.ogm.width = 16;
  map.ogm.height = 16;
  map.ogm.resolution = 0.1;

  RCLCPP_INFO(get_logger(), "now sending");

  map_send_->publish(map);
}

/**
 * 
 * @param options 
 */
SendClient::SendClient(rclcpp::NodeOptions /*in*/options) :
    rclcpp_lifecycle::LifecycleNode("SendClient", options) {
  cbg_Request_ = create_callback_group(
      rclcpp::CallbackGroupType::MutuallyExclusive);
  cbg_t_Request_ = create_callback_group(
      rclcpp::CallbackGroupType::MutuallyExclusive);

  rclcpp::PublisherOptions map_options;
  map_options.callback_group = cbg_Request_;
  map_send_ = create_publisher < simple_msgs::msg::Map
      > ("map", 1, map_options);
  // directly activate a publisher
  map_send_->on_activate();

}

} // of namespace sendReceive

/************************************************************
 End of SendClient class body
 ************************************************************/
